section(anchor='s-motion-lib')
  name motion-lib

  section
    name Global Overview

    t
      | The motion-lib is a C++ library intended to abstract underlying hardware
      | and ease the business logic implementation in #[xref(target="FESA") CERN FESA framework],
      | by providing high-level device objects such as Axis, PositionSensors and Triggers.

    t
      | It implements all the required drivers and setup to communicate with the hardware,
      | using appropriate libraries and utilities such as #[xref(target="EDGE") CERN Edge].

    t
      | In addition to this it also embeds an HTTP/REST API that exposes the entire
      | interface and allows advanced hardware inspection and debugging,
      | this API is also extensively used in functional and integration testing of the SAMbuCa solution.


    figure
      name Motion-Lib Overview
      artwork(align='center' type='binary-art' src='motion-control-software-architecture/motionlib_uml.png')

    t
      | The motion-lib is split in two parts: a public part which includes
      | #[xref(target="s-motion-lib-devices") Devices] and a
      | #[xref(target="s-motion-lib-controller") Controller] to access those,
      | and a private part which includes #[xref(target="s-motion-lib-platforms") Platforms].


    t
      | Complete API documentation is available  #[xref(target='MOTIONLIB_API') here].

  section(anchor='s-motion-lib-controller')
    name Controller

    t
      | The Controller is the main entry-point to motion-lib, it provides an access
      | to Devices through the DeviceStore.

  section(anchor='s-motion-lib-devices')
    name Devices

    t
      | Devices are simple shared objects, each device #[bcp14 MUST] be identified
      | by a unique identifier, it #[bcp14 MUST] be predictible depending on the
      | underlying hardware, a URL scheme #[bcp14 SHOULD] be used.

    t
      | Each device #[bcp14 MUST] provide an asynchronuous interface to interact
      | with its associated physical device, this
      | interface #[bcp14 SHOULD] be based on C++11 STL's #[tt std::future]
      | providing some flexibility to end-user.

    t
      | Here's an example device interface, for complete documentation, please
      | refer to #[xref(target='MOTIONLIB_API') motion-lib API documentation].
    figure
      name Example device interface
      sourcecode(type='C++' src='motion-control-software-architecture/device_use_example.cpp')

  section(anchor='s-motion-lib-platforms')
    name Platforms

    t
      | Platforms implement the back-end part of the motion-lib, managing physical-devices
      | communication.

    t
      | Each platform #[bcp14 MAY] run one or several threads and #[bcp14 MUST]
      | handle the communication with physical devices.

    section
      name Grbl platform

    section
      name MGrbl platform
